using UnityEngine;
using System.Collections;

class Lemming : MonoBehaviour
{

int _id;
UnityEngine.Color _color;
StatusEnum _status;
int _timeInStatus;
int _finishTimeinstatus;
ArrayList _sentances;
Animation _animationObj = new Animation();
int turn;   
bool _turning = false;
bool _moving = false;
float _angle = 0f;     
float _speed = 3.0f;
float _rotateSpeed = 3.0f;
float _distance = 0f;
bool _running = false;
int _angleR = 0;     
bool _turningR = false;
float _distanceR = 0f;

public enum StatusEnum
{
    Talk = 0,
    Walk = 1,
    Stare = 2,
    Freeze = 3
}

public Lemming()
{
    _status = StatusEnum.Freeze;
    _timeInStatus = 0;
    _id = 0;
    InitalizeFinishTimeinstatus();
}


private void Walk()
{
	/* Animation.CrossFade("Walk")
	System.Random randomTime = new System.Random();
	_angle = randomTime.Next(0, 180);
	CharacterController controller = (CharacterController)GetComponent(typeof(CharacterController));
	Vector3 forward = transform.TransformDirection(Vector3.forward);
	float curSped = 500f;
	controller.SimpleMove(forward * curSped);	
	*/
	_angle = LavelManagersrc._randomNumber.Next(-180, 180);
	_distance = LavelManagersrc._randomNumber.Next (10,30);	
	_moving = true;
	// Play Walk sound
}

public void Run()
{
	/* Animation.CrossFade("Walk")
	*/
	_distanceR = LavelManagersrc._randomNumber.Next (20,40);	
	_running = true;
	_moving = false;
	// Play Walk sound
}


private void Stare()
{
//    _animationObj.CrossFade("Stare");

    // Play Stare sound
}

private void Talk()
{
//    _animationObj.CrossFade("Stare");
		this.audio.Play();		
}


private void InitalizeFinishTimeinstatus()
{
    _finishTimeinstatus = LavelManagersrc._randomNumber.Next(0, 50) + 50;
}

public void Idle()
{

	CharacterController controller = (CharacterController)GetComponent(typeof(CharacterController));
	if (_running)
	{
		Vector3 forward = transform.TransformDirection(Vector3.forward);
		controller.SimpleMove(forward * 20);
		_distanceR -= 1;
		if (_distanceR <= 0)
		{
		  _running = false;	
		}		
	}	
	else
		if (_moving)
		{
			if (_angle > 0)
			{
			_angle -= 3;
			transform.Rotate(0,3,0);			
			}
			else
			{
			_angle += 3;
			transform.Rotate(0,-3,0);						
			}
			Vector3 forward = transform.TransformDirection(Vector3.forward);
			controller.SimpleMove(forward * 10);
			_distance -= 1;
			if (_distance <= 0)
			{
			  _moving = false;	
			}		
		}
		else
			controller.SimpleMove(Vector3.up);
		
	

    ++_timeInStatus;

    if (_timeInStatus == _finishTimeinstatus)
    {
        _timeInStatus = 0;
        InitalizeFinishTimeinstatus();

        // Change status
            //UnityEngine.Random randomObj = new UnityEngine.Random();
            
            float status =  LavelManagersrc._randomNumber.Next(0, 50);

            // Choose new status randomly.
            if (status > 48 && status < 50)
            {
                Talk();
                _status = StatusEnum.Walk;
            }
            else
            {
	            if (status > 0 && status < 45)
	            	{
		                Walk();
		                _status = StatusEnum.Walk;
	            	}
            }
    }
}

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	 Idle();

	}
	
}